#!/usr/bin/env node
import h from "node:path";
import a from "node:fs";
import S from "lodash.get";
import J from "lodash.set";
import { log as t } from "@done-coding/cli-utils";
const w = /(?<!\/):/, x = (e) => {
  const [r, o = r, ...s] = e.split(w);
  return {
    key: r,
    /** 目标key */
    targetKey: o,
    /** 参数列表 */
    paramsList: s
  };
}, v = ({
  valueInit: e,
  paramsList: r
}) => {
  const [o, ...s] = r;
  switch (o) {
    case "REG": {
      const [n, l, u] = s, f = new RegExp(n, u ?? void 0);
      return typeof e == "string" ? e.replace(f, l) : (t.warn(
        `${e}不是字符串类型，无法使用正则表达式进行替换，此处将直接返回原值`
      ), e);
    }
    case "VALUE": {
      const [n] = s;
      return n;
    }
    default:
      return e;
  }
}, $ = async (e) => {
  const { sourceJsonFilePath: r, injectKeyPath: o, injectInfoFilePath: s } = e, n = process.cwd();
  if (!r.endsWith(".json"))
    return t.error("源文件必须是json"), process.exit(1);
  if (!s.endsWith(".json"))
    return t.error("注入文件必须是json"), process.exit(1);
  const l = h.resolve(n, r), u = a.readFileSync(l, "utf-8"), f = JSON.parse(u), p = o.reduce(
    (c, m) => {
      const { key: y, targetKey: d, paramsList: j } = x(m);
      if (!y)
        return t.error(`注入key不能为空,请检查配置${m}是否正确`), c;
      const F = S(f, y), P = v({
        valueInit: F,
        paramsList: j
      });
      return J(c, d, P), c;
    },
    {}
  ), i = h.resolve(n, s), g = JSON.stringify(p, null, 2);
  if (a.existsSync(i)) {
    const c = a.readFileSync(i, "utf-8");
    if (g === c)
      return t.skip("注入文件已存在且内容相同，无需重复注入"), p;
    t.stage("文件内容变化,开始覆盖注入文件");
  } else
    t.stage("开始注入文件");
  return a.writeFileSync(i, g), console.log(
    t.success(`文件注入成功: ${i}`),
    t.info(g)
  ), p;
};
export {
  $ as h
};
