#!/usr/bin/env node
import { h as i } from "./handler-995d55e6.js";
import c from "yargs";
import { hideBin as l } from "yargs/helpers";
import { log as s } from "@done-coding/cli-utils";
const o = {
  version: "0.4.7-alpha.0",
  name: "@done-coding/cli-inject",
  description: "信息注入命令行工具",
  cliConfig: {
    namespaceDir: ".done-coding",
    moduleName: "inject"
  }
}, m = () => ({
  sourceJsonFilePath: {
    type: "string",
    alias: "s",
    describe: "信息源json文件相对路径",
    default: "./package.json"
  },
  injectKeyPath: {
    type: "array",
    alias: "k",
    describe: "需要注入的key路径",
    default: ["name", "version", "description"]
  },
  injectInfoFilePath: {
    type: "string",
    alias: "i",
    describe: "注入信息文件路径",
    default: "./src/injectInfo.json"
  }
}), a = o.cliConfig.moduleName, d = (e, n) => {
  e ? s.error(e) : s.error(n.message), process.exit(1);
}, p = o.description, g = `Usage: $0 ${a} [options]`, f = "Usage: $0 [options]", t = (e, n) => {
  const r = m();
  return e.strict().usage(n).help("help").version(o.version).alias("v", "version").alias("h", "help").options(r).fail(d).argv;
}, u = (e) => t(e, g), b = {
  command: a,
  describe: p,
  builder: u,
  handler: i
}, C = async () => {
  const e = c(l(process.argv)), n = await t(e, f);
  return i(n);
};
export {
  b as a,
  C as c
};
